package controlador;



import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.GregorianCalendar;

import com.pillcontrol.medicinas.R;



import modelo.DatePickerFragment;
import modelo.TimePickerFragment;
import modelo.Toma;
import modelo.TomaAdapter;
import modelo.TomaDbAdapter;







import android.annotation.SuppressLint;
import android.app.AlarmManager;
import android.app.AlarmManager;
import android.app.AlertDialog;
import android.app.ListActivity;

import android.content.DialogInterface;
import android.content.Intent;

import android.os.Bundle;


import android.util.Log;
import android.view.ContextMenu;
import android.view.ContextMenu.ContextMenuInfo;

import android.view.Menu;
import android.view.MenuItem;
import android.view.View;

import android.widget.AdapterView.AdapterContextMenuInfo;
import android.widget.ListView;






public class TomaActivity extends ListActivity{
//public class TomaActivity extends FragmentActivity{
    public static final String C_MODO  = "modo" ;
    public static final int C_VISUALIZAR = 551 ;
    public static final int C_CREAR = 552 ;
    public static final int C_EDITAR = 553 ;
    public static final int C_ELIMINAR = 554 ;
    public static final int C_CONFIGURAR = 555 ;
    public static final int C_VOLVER = 556 ;	
    public static final int C_BOTONERA = 557 ;
    static final int DATE_DIALOG_ID = 999;  
	static final int HOUR_DIALOG_ID = 000;
	private TomaDbAdapter dbAdapter;
	private String dia;
    private TomaAdapter TomasAdapter ;
   
    private ListView lista;
    private String filtro ;
   
    AlarmManager alarmManager;
    Intent i2;
	
   
	@Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_toma);
        Intent intent = getIntent();
        String date;
		Bundle extra = intent.getExtras();
		if (extra.getString("fecha")==null)
			date="";
		else
			date = extra.getString("fecha");
	//	 getActionBar().setTitle("Tomas Da: "+ date);
        lista = (ListView) findViewById(android.R.id.list);
        showDialog(DATE_DIALOG_ID);
        dbAdapter = new TomaDbAdapter(this);
        dbAdapter.abrir();
       // mostrarDialogoDeFecha(View v);
       // SimpleDateFormat sdf = new SimpleDateFormat("yyyy/M/d HH:mm:ss:ss"); 
        SimpleDateFormat sdf = new SimpleDateFormat("dd/MM/yyyy"); 
        Calendar c1 = GregorianCalendar.getInstance();
         String dia1=sdf.format(c1.getTime());  
         
         c1.add(Calendar.DATE, 1);
        dia1=sdf.format(c1.getTime());
        c1.add(Calendar.DATE, 2);
         String dia2=sdf.format(c1.getTime());
	   // filtro = new String("hip_tomada = 0 and hip_flarga BETWEEN " + "'" + dia1 + "'" + " AND "  + "'" + dia2 + "'"); 
        
         Log.d("Dia", dia1);
         Log.d("Dia", dia2);
        
        
        
     
	     
	
	     filtro = new String("hip_tomada = 0 and hip_fecha like " + "'" + date + "'" );
	
        Log.d("Filtro", filtro);
        
        
     
	     
	 
        Log.d("Filtro", filtro);
        //solo nos muestre las tomas PENDIETES
      
        consultar();

       registerForContextMenu(this.getListView());
        
        
        
        
      
       
       
    }
  
    
    
    public void consultar()
    {
        TomasAdapter = new TomaAdapter(this, dbAdapter.getTomas(filtro));

        lista.setAdapter(TomasAdapter);
    }
	
        
        
		
	
	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		// Inflate the menu; this adds items to the action bar if it is present.
		getMenuInflater().inflate(R.menu.toma, menu);
		return true;
	}
	
	
	
	@Override

	protected void onListItemClick(ListView l, View v, int position, long id)
	{
		super.onListItemClick(l, v, position, id);
		
		visualizar(id);
	}
	private void visualizar(long id)
	{
		// Llamamos a la Actividad TomaFormulario indicando el modo visualizacin y el identificador del registro 
		Intent i = new Intent(TomaActivity.this, TomaFormulario.class);
		 
		i.putExtra(C_MODO, C_VISUALIZAR);
		i.putExtra(TomaDbAdapter.C_COLUMNA_ID, id);
	
						
		startActivityForResult(i, C_VISUALIZAR);
		finish();
	
	}
    @Override
    public boolean onMenuItemSelected(int featureId, MenuItem item)
    {
        Intent i;

        switch (item.getItemId())
        {
           
            case R.id.menu_volver:
            	finish();
            	i = new Intent(TomaActivity.this, PantallaPrincipal.class);
                startActivityForResult(i, C_CONFIGURAR);
            	
            	return true;
           
        }
        return super.onMenuItemSelected(featureId, item);
    }
    private void borrarTodos(){
    	//dbAdapter.cerrar();
    	TomaDbAdapter dbAdapter4 = new TomaDbAdapter(this);
        dbAdapter4.abrir();
        filtro = new String("hip_tomada = 0"); 
         
        //   filtro = new String("");   		
       	    Log.d("Filtro",  filtro);
       	   TomaAdapter TomasAdapter = new TomaAdapter(this, dbAdapter4.getTomas2(filtro));
       	    Log.d("TomasEliminadas",  Integer.toString(TomasAdapter.getCount()));
       	    
       	    // filtro = filtro + sf.toString();
       	   
       		 Toma t;

       	    for (int i=0; i<TomasAdapter.getCount(); i++){
       	    	t = TomasAdapter.getItem(i);
       	    	t.delete();
       	    
       	    	Log.d("TomasEliminadas", Long.toString(t.getId_medicamento()) );
       	    	
       	    }
       	     Log.d("Filtro", filtro);
        dbAdapter.cerrar();
        finish();
    }
	
    @Override
    protected void onActivityResult(int requestCode, int resultCode, Intent data)
    {
        //
        // Nos aseguramos que es la peticin que hemos realizado
        //
        switch(requestCode)
        {
            case C_CREAR:
                if (resultCode == RESULT_OK)
                    consultar();

            case C_VISUALIZAR:
                if (resultCode == RESULT_OK)
                    consultar();
            case C_VOLVER:
               finish();
               
            case C_CONFIGURAR:
                // en la PreferenceActivity no hemos definido ningn resultado por lo que recargamos
                // siempre las preferencias
    //         getPreferencias();
                consultar();

            default:
                super.onActivityResult(requestCode, resultCode, data);
        }
    }
	
	private void borrar(final long id)
	{
		/*
		 * Borramos el registro y refrescamos la lista
		 */
		AlertDialog.Builder dialogEliminar = new AlertDialog.Builder(this);
		
		dialogEliminar.setIcon(android.R.drawable.ic_dialog_alert);
	//	
		dialogEliminar.setCancelable(false);
		
		dialogEliminar.setPositiveButton(getResources().getString(android.R.string.ok), new DialogInterface.OnClickListener() {

			public void onClick(DialogInterface dialog, int boton) {
				dbAdapter.delete(id);
				//Toast.makeText(TomaActivity.this, R.string.Toma_eliminar_confirmacion, Toast.LENGTH_SHORT).show();
				consultar();				
			}
		});
		
		dialogEliminar.setNegativeButton(android.R.string.no, null);
		
		dialogEliminar.show();
	}

	@Override
	public void onCreateContextMenu(ContextMenu menu, View v, ContextMenuInfo menuInfo) {
		super.onCreateContextMenu(menu, v, menuInfo);

		menu.setHeaderTitle(TomasAdapter.getItem(((AdapterContextMenuInfo) menuInfo).position).getFecha());
		menu.add(Menu.NONE, C_VISUALIZAR, Menu.NONE, R.string.menu_visualizar);
		menu.add(Menu.NONE, C_EDITAR, Menu.NONE, R.string.menu_editar);
		menu.add(Menu.NONE, C_ELIMINAR, Menu.NONE, R.string.menu_eliminar);
		menu.add(Menu.NONE, C_VOLVER, Menu.NONE, R.string.menu_volver);
	}
	
	@Override
	public boolean onContextItemSelected(MenuItem item) {
		
		AdapterContextMenuInfo info = (AdapterContextMenuInfo) item.getMenuInfo();
		Intent i;
		
		switch(item.getItemId())
		{
	    	case C_ELIMINAR:
	    		borrar(info.id);
	    		return true;
	    	
	    	case C_VISUALIZAR:
	    		visualizar(info.id);
				return true;
				
	    	case C_EDITAR:
	    		i = new Intent(TomaActivity.this, TomaFormulario.class);
	    		i.putExtra(C_MODO, C_EDITAR);
	    		i.putExtra(TomaDbAdapter.C_COLUMNA_ID, info.id);
				
	    		startActivityForResult(i, C_EDITAR);
				return true;
				
	    	case C_VOLVER:
	    		cancelar();
	    		return true;
	    		
	    }
	    return super.onContextItemSelected(item);
	}
	private void cancelar()
	{
		setResult(RESULT_CANCELED, null);
		finish();
	}
	
	
}
