package modelo;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.TextView;


import java.util.ArrayList;



public class PerfilAdapter extends ArrayAdapter<Perfil>
{
    private static class ViewHolder {
        TextView text1;
    }

 public PerfilAdapter(Context context, ArrayList<Perfil> perfil) {
    	
      super(context, android.R.layout.simple_dropdown_item_1line, perfil);
        
  }

    @Override
    public View getView(int position, View convertView, ViewGroup parent) {

        Perfil perfils = getItem(position);

        ViewHolder viewHolder;

        if (convertView == null)
        {
            viewHolder = new ViewHolder();
            LayoutInflater inflater = LayoutInflater.from(getContext());
            convertView = inflater.inflate(android.R.layout.simple_dropdown_item_1line, parent, false);
            viewHolder.text1 = (TextView) convertView.findViewById(android.R.id.text1);
            convertView.setTag(viewHolder);
        }
        else
        {
            viewHolder = (ViewHolder) convertView.getTag();
        }

        viewHolder.text1.setText(perfils.getNombre());

        return convertView;
    }

    @Override
    public long getItemId(int position)
    {
        return getItem(position).getId();
    }
}
