package controlador;

import java.util.ArrayList;
import java.util.Calendar;

import com.pillcontrol.medicinas.R;



import modelo.PerfilDbAdapter;
import modelo.TimePickerFragment;

import servicio.Servicio;









import android.support.v4.app.DialogFragment;
import android.support.v7.app.ActionBarActivity;
import android.app.AlarmManager;
import android.app.AlertDialog;
import android.app.DatePickerDialog;
import android.app.Dialog;
import android.app.ListActivity;
import android.app.PendingIntent;
import android.app.TimePickerDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.DialogInterface.OnClickListener;
import android.nfc.NdefMessage;
import android.os.Bundle;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.Menu;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.BaseAdapter;
import android.widget.ImageView;
import android.widget.ListAdapter;
import android.widget.ListView;
import android.widget.TextView;
import android.widget.Toast;

public class PantallaPrincipal extends ListActivity {
	
    private ListView lista;
    private static PendingIntent pendingIntent=null;
    public static final String C_MODO  = "modo" ;
    public static final int C_VISUALIZAR = 551 ;
    public static final int C_CREAR = 552 ;
    public static final int C_EDITAR = 553 ;
    public static final int C_ELIMINAR = 554 ;
    public static final int C_CONFIGURAR = 555 ;
    public static final int C_NOTIFICAR = 556 ;
    public static final int C_CAMARA = 557 ;
    public static final int C_TOMA = 558 ;
    public static final int C_HOY = 560 ;	
    public static final int C_PASADAS = 561 ;	
    public static final int C_HISTORIAL = 562 ;
    public static final int C_ALMACEN = 562;

	@Override
	protected void onCreate(Bundle savedInstanceState) {
	
		 if(pendingIntent == null){ //Comprueba si el servicio ya esta iniciado
	        	//Se ejecuta el servicio que genera las notificacion y alarmas
	        	  Intent myIntent = new Intent(this, Servicio.class);
	        	  Log.d("inicio ","servicio");
	              pendingIntent = PendingIntent.getService(this, 0, myIntent, 0);
	  
	              AlarmManager alarmManager = (AlarmManager)getSystemService(ALARM_SERVICE);
	  
	              Calendar calendar = Calendar.getInstance();
	              calendar.setTimeInMillis(System.currentTimeMillis());
	              calendar.add(Calendar.SECOND, 10);
	              alarmManager.setRepeating(AlarmManager.RTC_WAKEUP, calendar.getTimeInMillis(), 59 * 1000, pendingIntent);
	        }
		super.onCreate(savedInstanceState);
		setData();
		mAdapter = new MyAdapter(this);
		setListAdapter (mAdapter);
	}
	
	@Override
	protected void  onListItemClick(ListView lv, View v, int position, long id){
		 super.onListItemClick(lv, v, position, id);
			 switch (position) {
			 case 0:
				 finish();
				
            		Intent actividad = new Intent (this, HoyActivity.class);
            		 actividad.putExtra(C_MODO, C_HOY);
				 startActivity(actividad);
				 
				 return;
			 case 1:
				 finish();
				
				 Intent actividad1 = new Intent (this, MedicinaActivity.class);
				 actividad1.putExtra(C_MODO, C_VISUALIZAR);
				startActivity(actividad1); 
				finish();
				 return;
				 
				 
				 case 2:
					 finish();
						
					 Intent actividad3 = new Intent (this, SeleccionDia.class);
								 
					 startActivity(actividad3); 
					 return;
				 case 3:
					 finish();
						
					 Intent actividad4 = new Intent (this, HoyActivity.class);
					 actividad4.putExtra(C_MODO, C_HISTORIAL);
					 
					 startActivity(actividad4);
					 return;
				 case 4:
					 						
					 finish();
	            	Intent actividad9 = new Intent (this, HoyActivity.class);
	            	actividad9.putExtra(C_MODO, C_PASADAS);
					startActivity(actividad9);
					
					 return;
				 case 5:
					 finish();
					
					Intent actividad5 = new Intent (this, EtiquetaNFC.class);
					 actividad5.putExtra(C_MODO, C_VISUALIZAR);
		       		startActivity(actividad5);
				 return;
				 case 6:
						
					 finish();
	            	Intent actividad45 = new Intent (this, MedicinaActivity.class);
	            	
	            	actividad45.putExtra(C_MODO, C_ALMACEN);
				
					
					startActivity(actividad45);
					finish();
				
					 return;
				 case 7:
						
					 finish();
	            	Intent actividad100 = new Intent (this, Configurar.class);
	            	
					startActivity(actividad100);
				
					 return;
		
			 }
			}
		
	private MyAdapter mAdapter = null;
	public class Node
	{
		public String mTitle;
		public Integer mImageResource;
		public String mhorario;
		public String medades;
	}
	private void salir()
	{
		/*
		 * Borramos el registro con confirmación
		 */
		AlertDialog.Builder dialogEliminar = new AlertDialog.Builder(this);
		
		dialogEliminar.setIcon(android.R.drawable.ic_dialog_alert);
		dialogEliminar.setTitle("Esta seguro de querer borrar esta toma");
	
		dialogEliminar.setCancelable(false);
		
		dialogEliminar.setPositiveButton(getResources().getString(android.R.string.ok), new DialogInterface.OnClickListener() {

			public void onClick(DialogInterface dialog, int boton) {
				//positivo
				Toast.makeText(PantallaPrincipal.this, "Salir", Toast.LENGTH_SHORT).show();
				/*
				 * Devolvemos el control
				 */
				setResult(RESULT_OK);
				finish();
			}
		});
	}
	
	
	private void salir2() {
        new AlertDialog.Builder(this).setTitle("Esta seguro que quiere salir de la aplicacin")
            .setPositiveButton("Si", new DialogInterface.OnClickListener() {
                @Override
                public void onClick(DialogInterface arg0, int arg1) {
                finish();   
                }
            })
            .setNegativeButton("No", new DialogInterface.OnClickListener() {
                @Override
                public void onClick(DialogInterface arg0, int arg1) {
                    
                }
            }).show();
    }
	
	
	
	
	
	
	
	
	
	private static ArrayList<Node> mArray = new ArrayList<Node>();
	
	private void setData(){
		mArray.clear();
		//Pelicula0
		Node mynode0 = new Node();
		mynode0.mTitle = "Calendario Tomas para hoy";
		mynode0.mImageResource = R.drawable.ihoy; //Aqui me creo las imagenes
		mynode0.mhorario = "Las medicinas que debo tomar HOY";
		mynode0.medades = this.getResources().getString(R.string.edades0);
		mArray.add(mynode0);
		
		//Pelicula1
		Node mynode1 = new Node();
		mynode1.mTitle = this.getResources().getString(R.string.title1);
		mynode1.mImageResource = R.drawable.iconomedicina; //Aqui me creo las imagenes
		mynode1.mhorario = this.getResources().getString(R.string.horario1);
		mynode1.medades = this.getResources().getString(R.string.edades1);
		mArray.add(mynode1);
		//Pelicula2...
		Node mynode2 = new Node();
		mynode2.mTitle = this.getResources().getString(R.string.title2);
		mynode2.mImageResource = R.drawable.iconotomas; //Aqui me creo las imagenes
		mynode2.mhorario = this.getResources().getString(R.string.horario2);
		mynode2.medades = this.getResources().getString(R.string.edades2);
		mArray.add(mynode2);Node mynode3 = new Node();
		//esto tiene que ser una busqueda de los medicamentos en la base de datos correspondiente
		mynode3.mTitle = this.getResources().getString(R.string.title3);
		mynode3.mImageResource = R.drawable.itoma; //Aqui me creo las imagenes
		mynode3.mhorario = this.getResources().getString(R.string.horario3);
		mynode3.medades = this.getResources().getString(R.string.edades3);
		mArray.add(mynode3);
		Node mynode4 = new Node();
		mynode4.mTitle = "Tomas olvidadas";
		mynode4.mImageResource = R.drawable.iolvido; //Aqui me creo las imagenes
		mynode4.mhorario = "Tomas pendientes de tomar";
		mynode4.medades = "";
		mArray.add(mynode4);
		Node mynode5 = new Node();
		mynode5.mTitle = this.getResources().getString(R.string.title5);
		mynode5.mImageResource = R.drawable.infc; //Aqui me creo las imagenes
		mynode4.mhorario = this.getResources().getString(R.string.horario5);
		mynode5.medades = this.getResources().getString(R.string.edades5);
		mArray.add(mynode5);
		Node mynode6 = new Node();
		mynode6.mTitle = "Almacen de medicamentos";
		mynode6.mImageResource = R.drawable.ialmacen; //Aqui me creo las imagenes
		mynode6.mhorario = "";
		mynode6.medades = this.getResources().getString(R.string.edades4);
		mArray.add(mynode6);
	//	mArray.add(mynode5);
		Node mynode7 = new Node();
		mynode7.mTitle = "Configuracin";
		mynode7.mImageResource = R.drawable.iconfiguracion; //Aqui me creo las imagenes
		mynode7.mhorario = "Eliminar calendarios y medicinas";
		mynode7.medades = "";
		mArray.add(mynode7);
		
		}
	
	
	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
	
	    MenuInflater inflater = getMenuInflater();
	    inflater.inflate(R.menu.principal, menu);
	    return super.onCreateOptionsMenu(menu);
	}
	

		
	public boolean onMenuItemSelected(int featureId, MenuItem item) {
		
		switch (item.getItemId())
		{
			case R.id.menu_eliminar:
				salir();
				return true;
				
			case R.id.menu_cancelar:
				finish();
			    Intent actividad3 = new Intent (this,TomaActivity.class);
			    startActivity(actividad3);
				return true;
				
			case R.id.menu_guardar:
				salir();
				return true;
				
			case R.id.salir:
				//salir();
				salir2();
				return true;
			case R.id.menu_atras:
				 finish();
				   actividad3 = new Intent (this,TomaActivity.class);
				    startActivity(actividad3);
			case R.id.menu_volver:
				 finish();
				   actividad3 = new Intent (this,TomaActivity.class);
				    startActivity(actividad3);
				 return true;
			case R.id.perfil:
					finish();
					Intent i = new Intent(this, PerfilFormulario.class);
					
					i.putExtra(C_MODO, C_VISUALIZAR);
				
					startActivityForResult(i, C_VISUALIZAR);
				
					return true;
				case R.id.escribirNFC:
					finish();
					startActivity(new Intent(this, EtiquetaNFC.class).putExtra(C_MODO, C_EDITAR));
					return true;
		}
		
		return super.onMenuItemSelected(featureId, item);
	}
	
	

	public static class MyAdapter extends BaseAdapter{
		private Context mContext;
		public MyAdapter (Context c){mContext = c;}
		
		
		public int getCount() {
		// TODO Auto-generated method stub
			return mArray.size();
		}
		
		
		public Object getItem(int position) {
		// TODO Auto-generated method stub
			return mArray.get(position);
		}
		
		
		public long getItemId(int position) {
		// TODO Auto-generated method stub
			return 0;}
		
		
		public View getView(int position, View convertView, ViewGroup parent) {
		// TODO Auto-generated method stub
			View view = null;
			if (convertView == null){
					LayoutInflater inflater = (LayoutInflater) 
							mContext.getSystemService(Context.LAYOUT_INFLATER_SERVICE);
					view = inflater.inflate(R.layout.activity_principal, null);
			}else{
				view = convertView;
			}
			
			ImageView img = (ImageView) (ImageView) view.findViewById(R.id.logo);
			img.setImageDrawable 
			(mContext.getResources().getDrawable(mArray.get(position).mImageResource));
			
			TextView tTitle = (TextView) view.findViewById(R.id.nomPelicula);
			tTitle.setText(mArray.get(position).mTitle);
			
			TextView hTitle = (TextView) view.findViewById(R.id.horaPelicula);
			hTitle.setText(mArray.get(position).mhorario);
			
			TextView eTitle = (TextView) view.findViewById(R.id.edadesPelicula);
			eTitle.setText(mArray.get(position).medades);
			
			
			return view;
		}
		}
}
