package controlador;





import android.net.Uri;
import android.os.Build;
import android.os.Bundle;
import android.os.Environment;

import android.support.v4.app.FragmentActivity;
import android.support.v4.app.NotificationCompat;
import android.support.v4.app.NotificationManagerCompat;
import android.util.Log;
import android.view.Menu;
import android.view.View;


import android.annotation.TargetApi;

import android.app.AlertDialog;

import android.content.ContentResolver;
import android.content.DialogInterface;
import android.content.Intent;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;

import android.view.MenuItem;

import android.widget.Button;

import android.widget.EditText;
import android.widget.ImageView;
import android.widget.LinearLayout;

import android.widget.Toast;

//import android.support.v4.app.DialogFragment;


import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.InputStream;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.GregorianCalendar;

import com.pillcontrol.medicinas.R;




import modelo.Medicina;
import modelo.MedicinaAdaptador;
import modelo.MedicinaDbAdapter;
import modelo.Toma;
import modelo.TomaDbAdapter;





import android.app.DatePickerDialog;
import android.app.Activity;

import android.app.Dialog;
import android.app.Notification;
import android.app.Notification.BigTextStyle;
import android.app.NotificationManager;
import android.app.PendingIntent;

import android.view.View.OnClickListener;

import android.widget.DatePicker;
import android.widget.TextView;







//import android.app.FragmentActivity;




@TargetApi(Build.VERSION_CODES.FROYO)
public class TomaFormulario extends FragmentActivity {
	

	private int modo ;
	public static final int APP_ID_NOTIFICATION = 0;
	//
	// Identificador del registro que se edita cuando la opción es MODIFICAR
	//
	private long id ;
    private Toma toma = new Toma(this);
	
    //
    // Elementos de la vista
    //
    public static final int C_BOTONERA = 557 ;
    public static final String C_MODO  = "modo" ;
    public static final int C_HOY = 560 ;	
    public static final int C_PASADAS = 561 ;	
    public static final int C_HISTORIAL = 562 ;
    private EditText cantidad;
    private Medicina medicina;
    private EditText tomada;
    private EditText id_medicamento;
    private EditText duracion;
    private EditText hora;
    private EditText fecha;
	private Button boton_guardar;
	private Button boton_cancelar;
	private  NotificationManager mManager;
	private Button boton_fecha;
	private Button boton_hora;
	private String filtro ;
	private MedicinaDbAdapter dbAdapter;
    private MedicinaAdaptador medicinasAdapter ;
    String cronico;
	private int year;
	private int month;
	private int day;
	private int horas;
	private int minuto;
	private int cantidades;
	static final int DATE_DIALOG_ID = 999;  
	static final int HOUR_DIALOG_ID = 000;
	 private final String ruta_fotos = Environment.getExternalStoragePublicDirectory(Environment.DIRECTORY_PICTURES) + "/misfotos/";
	    private File file = new File(ruta_fotos);
	    private String ruta = new String(ruta_fotos);
	    InputStream filename = null;
		
		
	private ImageView imagen;
	
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		
		setContentView(R.layout.activity_toma_formulario);
			
		Intent intent = getIntent();
		Bundle extra = intent.getExtras();
		//vista
        cantidad = (EditText) findViewById(R.id.cantidad);
        hora = (EditText) findViewById(R.id.hora);
        cantidad = (EditText) findViewById(R.id.cantidad);
        fecha = (EditText) findViewById(R.id.fecha);
        tomada = (EditText) findViewById(R.id.tomada);
        id_medicamento = (EditText) findViewById(R.id.id_medicamento);
        tomada = (EditText) findViewById(R.id.tomada);
      
        imagen=(ImageView)findViewById(R.id.imagen);
        duracion = (EditText) findViewById(R.id.duracion);
        
        fecha = (EditText) findViewById(R.id.fecha);
        
        boton_guardar = (Button) findViewById(R.id.boton_guardar);
		boton_cancelar = (Button) findViewById(R.id.boton_cancelar);
		
		
		// Obtenemos el identificador del registro si viene indicado
		//
		 
		 if (extra == null) return;
		if (extra.containsKey(TomaDbAdapter.C_COLUMNA_ID))
		{
			id = extra.getLong(TomaDbAdapter.C_COLUMNA_ID);
		
			
			consultar(id);
			
		}
		 
		
		establecerModo(extra.getInt(TomaActivity.C_MODO));//si vien de Toma Activity
		establecerModo(extra.getInt(HoyActivity.C_MODO));
		if (extra.containsKey(HoyActivity.C_MODO))
		{
			establecerModo(extra.getInt(TomaActivity.C_MODO));
			
		}
		//
		// Definimos las acciones para los dos botones
		//
		boton_guardar.setOnClickListener(new View.OnClickListener() {
			//Realizar la toma correspondiente
			@Override
			public void onClick(View v)
			{
				try {
					tomar();
				} catch (FileNotFoundException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
		});
	
		
		
		boton_cancelar.setOnClickListener(new View.OnClickListener() {
			
			@Override
			public void onClick(View v)
			{
				cancelar();	
				
			}
		});
	
	}
	
	
    private void establecerModo(int m)
    {
        this.modo = m ;
        
        if ((modo == TomaActivity.C_VISUALIZAR) && (modo==HoyActivity.C_VISUALIZAR))
        {
            this.setTitle("Tomar medicina");
           this.setEdicion(false);
        }
        else if (modo == TomaActivity.C_CREAR)
        {
          this.setTitle(R.string.toma_crear_titulo);
          this.setEdicion(true);
        }
        else if (modo == TomaActivity.C_EDITAR)
        {
          this.setTitle(R.string.toma_editar_titulo);
          this.setBotonera(true);
          this.setEdicion(true);
        }
        
        else if (modo == HoyActivity.C_BOTONERA){
        	this.setTitle("TOMA YA REALIZADA");
        	this.setBotonera(false);
        	this.setEdicion(false);
        }
        else{
        	this.setBotonera(false);
        	this.setEdicion(false);
        }
        
    }
	
private void consultar(long id)
{
    //
    // Consultamos la toma por el identificador
    //
	 
	 
    toma = Toma.find(this, id);
    
    String hor = "falla la hora";
    String fec = "falla la fecha";
    String lon = "falla la toma";
    String med = "falla el identificado de medicamento";
    
  //  lon = String.valueOf(toma.getTomada());
    fec = toma.getFecha().toString();
    hor = toma.getHora().toString();
    med = String.valueOf(toma.getId_medicamento());
    
    hora.setText(hor);
    cantidad.setText(toma.getCantidad().toString());
    fecha.setText(fec);
   
    if (toma.getTomada()==false)
    		tomada.setText("NO");
    else
    	tomada.setText("SI");
    try {
    	MedicinaDbAdapter dbAdapter = new MedicinaDbAdapter(this);
         dbAdapter.abrir();
        String filtro = new String("_id= " + toma.getId_medicamento());
        Log.d("IdMedicamento", filtro);
  //   
        //podemos hacer esta consulta porque solo va haber una respuesta
         MedicinaAdaptador medicinasAdapter = new MedicinaAdaptador(this, dbAdapter.getMedicinas(filtro));
         med = toma.getNombreMedicamento();
         if (medicinasAdapter.getCount()==1){ //exite la medicina no ha sido borrada
        	medicina = medicinasAdapter.getItem(0);
         	cantidades = Integer.parseInt(medicina.getCantidad());
         	cronico = medicina.getCronico();
         	if(medicina.getDescripcion()!=null)
         		{filename = new FileInputStream(medicina.getDescripcion());
         		BitmapFactory.Options options=new BitmapFactory.Options();
         		//options.inSampleSize = 100;
         		Bitmap bitmap = BitmapFactory.decodeStream(filename, null,options);
         		imagen.setImageBitmap(bitmap);
         		bitmap=null;}
         	else{ imagen.setImageDrawable(getResources().getDrawable(
   		            R.drawable.sinfoto));}
         	}
         else if (toma.getFoto()!=null){
    		//	Log.d("Foto", medicina.getDescripcion());
    			filename = new FileInputStream(toma.getFoto());
    			BitmapFactory.Options options=new BitmapFactory.Options();
    			options.inSampleSize = 20;
    			Bitmap bitmap = BitmapFactory.decodeStream(filename, null,options);
    			imagen.setImageBitmap(bitmap);
    			bitmap=null;
    	}else{
    				
    				imagen.setImageDrawable(getResources().getDrawable(
    	   		            R.drawable.sinfoto));
    			}
     	} catch (FileNotFoundException e1) {
 		// TODO Auto-generated catch block
     		e1.printStackTrace();
     		
     	}
    
 	//Se reduce el tamao de la foto.
 	
    //   bitmap=null;
     System.gc();
     id_medicamento.setText(med);


}





private void setEdicion(boolean opcion)
{
	
    cantidad.setEnabled(opcion);
    hora.setEnabled(opcion);
    cantidad.setEnabled(opcion);
    fecha.setEnabled(opcion);
    tomada.setEnabled(opcion);
    id_medicamento.setEnabled(opcion);
    
    
}
private void setBotonera(boolean opcion){
	  LinearLayout v = (LinearLayout) findViewById(R.id.botonera);
	   
	     if (opcion){
	         v.setVisibility(View.VISIBLE);
	         
	      }

	     else{
	         v.setVisibility(View.GONE);
	         
	     }    
}

	private void tomar() throws FileNotFoundException
	{
		toma.setTomada(true);
	
	
		
		Calendar c1 = GregorianCalendar.getInstance();
		 
		     SimpleDateFormat sdf = new SimpleDateFormat("yyyy/M/d HH:mm:ss:ss");
		     SimpleDateFormat sdf2 = new SimpleDateFormat("yyyy-MM-dd");   
		     
		     String dia=sdf.format(c1.getTime());
		     toma.setFtomada(dia);
		     cantidades--;
		     if ((cantidades<=3)&&(cronico.equals("SI"))){
		    	 Toast.makeText(TomaFormulario.this, "Debe comprar medicina de " +  toma.getNombreMedicamento(), Toast.LENGTH_SHORT).show();
		    	
		    	 NotificarCantidad();
		    	
		     }
		     medicina.setCantidad(Integer.toString(cantidades));
		     medicina.save();
		    		    		
		   
		toma.save();
	
		setResult(RESULT_OK);
	    finish();
	    Intent actividad3 = new Intent (this,HoyActivity.class);
	    actividad3.putExtra(C_MODO, C_HOY);
	    startActivity(actividad3); 
		 
		
	}
	private void cancelar()
	{
			
		toma.postponer();
		setResult(RESULT_OK);
	    finish();
	    Intent actividad3 = new Intent (this,HoyActivity.class);
	    actividad3.putExtra(C_MODO, C_HOY);
		 		 startActivity(actividad3); 
		
	}
	public void cancel() {
        finish();
    }
	
	@Override
	public boolean onCreateOptionsMenu(Menu menu) {

		menu.clear();
	    
		if (modo == TomaActivity.C_VISUALIZAR)
			getMenuInflater().inflate(R.menu.toma_formulario_ver, menu);
		
		
		else
		getMenuInflater().inflate(R.menu.toma_formulario_editar, menu);
	
		
		return true;
	}
	
@Override
public boolean onMenuItemSelected(int featureId, MenuItem item) {
	
	switch (item.getItemId())
	{
		case R.id.menu_eliminar:
			borrar(id);
			return true;
			
		case R.id.menu_cancelar:
			finish();
		    Intent actividad3 = new Intent (this,TomaActivity.class);
		    startActivity(actividad3);
			return true;
			
		case R.id.menu_guardar:
		try {
			tomar();
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
			return true;
			
		case R.id.menu_editar:
		establecerModo(TomaActivity.C_EDITAR);
			return true;
		case R.id.menu_atras:
			 finish();
			   actividad3 = new Intent (this,PantallaPrincipal.class);
			   actividad3.putExtra(C_MODO, C_HOY);
			    startActivity(actividad3);
		case R.id.menu_volver:
			 finish();
			   actividad3 = new Intent (this,PantallaPrincipal.class);
			   //actividad3.putExtra(C_MODO, C_HOY);
			    startActivity(actividad3);
			 return true;
	}
	
	return super.onMenuItemSelected(featureId, item);
}

	private void borrar(final long id)
	{
		/*
		 * Borramos el registro con confirmación
		 */
		AlertDialog.Builder dialogEliminar = new AlertDialog.Builder(this);
		
		dialogEliminar.setIcon(android.R.drawable.ic_dialog_alert);
		dialogEliminar.setTitle("Esta seguro de querer borrar esta toma");
	
		dialogEliminar.setCancelable(false);
		
		dialogEliminar.setPositiveButton(getResources().getString(android.R.string.ok), new DialogInterface.OnClickListener() {

			public void onClick(DialogInterface dialog, int boton) {
				toma.delete();
				Toast.makeText(TomaFormulario.this, "Eliminar toma", Toast.LENGTH_SHORT).show();
				/*
				 * Devolvemos el control
				 */
				setResult(RESULT_OK);
				
			}
		});
		
		dialogEliminar.setNegativeButton(android.R.string.no, null);
		
		dialogEliminar.show();
		
	}
	private void NotificarCantidad() throws FileNotFoundException {
		
        	if(toma.getFoto()!=null)
        	filename = new FileInputStream(toma.getFoto());
        	else if(medicina.getDescripcion()!=null)
        		filename = new FileInputStream(medicina.getDescripcion());
     		BitmapFactory.Options options=new BitmapFactory.Options();
     		options.inSampleSize = 20;
     		Bitmap bitmap = BitmapFactory.decodeStream(filename, null,options);
     		imagen.setImageBitmap(bitmap);
        	int notificationId = 001;
        	Notification notif = new NotificationCompat.Builder(getBaseContext())
            .setContentTitle("Debe comprar ms pastillas del siguiente medicamento " )
            .setContentText(toma.getNombreMedicamento())
            .setSmallIcon(R.drawable.ialmacen)
            .setLargeIcon(bitmap)
            .setSound(Uri.parse(ContentResolver.SCHEME_ANDROID_RESOURCE
        	        + "://" + getPackageName() + "/raw/almacen"))
          
           // .extend(wearableExtender)
            .build();
     
        	NotificationManagerCompat notificationManager =
        	        NotificationManagerCompat.from(getBaseContext());

        	// Issue the notification with notification manager.
        	notificationManager.notify(notificationId, notif);
 
     	}
	
}


