package modelo;



import android.annotation.SuppressLint;
import android.app.DatePickerDialog;
import android.app.Dialog;
import android.os.Bundle;
import android.support.v4.app.DialogFragment;
import android.widget.DatePicker;

import java.util.Calendar;

@SuppressLint("NewApi")
public class DatePickerFragment extends DialogFragment
        implements DatePickerDialog.OnDateSetListener {

    @Override
    public Dialog onCreateDialog(Bundle savedInstanceState) {
        // Use the current date as the default date in the picker
        final Calendar c = Calendar.getInstance();
        int year = c.get(Calendar.YEAR);
        int month = c.get(Calendar.MONTH);
        int day = c.get(Calendar.DAY_OF_MONTH);
        
        // Create a new instance of DatePickerDialog and return it
        return new DatePickerDialog(getActivity(), this, year, month, day);
    }
  
   
    public void onDateSet(DatePicker view, int selectedYear,
			int selectedMonth, int selectedDay) {
    	view.setMinDate(System.currentTimeMillis()-1000);
		int year = selectedYear;
		int month = selectedMonth;
		int day = selectedDay;
		StringBuilder fecha1 = new StringBuilder().append(month + 1)
				.append("/").append(day).append("/").append(year)
				.append(" ");
		// set selected date into textview
		String fecha = fecha1.toString();
		
		// set selected date into datepicker also
		
	}
}
