package modelo;

import android.annotation.SuppressLint;
import android.app.ProgressDialog;
import android.content.Context;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.Color;
import android.graphics.Matrix;
import android.graphics.drawable.Drawable;
import android.os.AsyncTask;
import android.os.Environment;
import android.text.Html;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.ImageView;
import android.widget.TextView;


import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.InputStream;
import java.util.ArrayList;

import com.pillcontrol.medicinas.R;






@SuppressLint("NewApi")
public class MedicinaAdaptador extends ArrayAdapter<Medicina>
{
	InputStream filename = null;
	
	@SuppressLint("NewApi")
	private final String ruta_fotos = Environment.getExternalStoragePublicDirectory(Environment.DIRECTORY_PICTURES) + "/misfotos/";
	private File file = new File(ruta_fotos);
	private String ruta = new String(ruta_fotos);
	static final int DATE_DIALOG_ID = 999;  
	static final int HOUR_DIALOG_ID = 000;
	private ImageView imagen;
	
    public MedicinaAdaptador(Context context, ArrayList<Medicina> medicinas) {
    	
        super(context, R.layout.activity_medicina2, medicinas);
       // System.out.println ("Creado medicina Adapter ");
    }

    @SuppressLint("ViewHolder")
	@Override
    public View getView(int position, View convertView, ViewGroup parent) {

        Medicina medicina = getItem(position);
       
            LayoutInflater inflater = LayoutInflater.from(getContext());
           
            convertView = inflater.inflate(R.layout.activity_medicina2, parent, false);
          
            TextView tTitle = (TextView) convertView.findViewById(R.id.nomPelicula);
       
			tTitle.setText(medicina.getNombre());
			
			TextView hTitle = (TextView) convertView.findViewById(R.id.horaPelicula);
		
			if(medicina.getCronico().contains("SI"))
				hTitle.setText("Tratamiento cronico" + Html.fromHtml("<br />") + "Dosis que quedan: " + medicina.getCantidad());
	   		    	
	   		    else
	   		    	hTitle.setText("Tratamiento hasta " + medicina.getUltimaGeneracion() + Html.fromHtml("<br />") + "Dosis que quedan: " + medicina.getCantidad());
			
			
			if (Integer.parseInt(medicina.getCantidad())<3)
				hTitle.setTextColor(Color.parseColor("#f20909"));
			imagen=(ImageView)convertView.findViewById(R.id.logo);
			TextView eTitle = (TextView) convertView.findViewById(R.id.edadesPelicula);
			//eTitle.setText(medicina.getNombre());
            ///FOTO GRTAFIA
			//System.out.println ("iNTENTO IMAGEN");
			try {
				   if (medicina.getDescripcion()!=null){
			    		//	descripcion = (EditText) findViewById(R.id.descripcion);
			    		//System.out.println("Contienen la FOTO SIGUIENTES  SSSSSSSSSS --> " + medicina.getDescripcion());
			    		filename = new FileInputStream(medicina.getDescripcion());
			    		BitmapFactory.Options options=new BitmapFactory.Options();
						  if(medicina.getDescripcion()=="") {
							  imagen.setImageDrawable(getContext().getResources().getDrawable(
								                   R.drawable.sinfoto));}
						  else{
							  
							  Bitmap bitmap = BitmapFactory.decodeStream(filename, null,options);
							  bitmap =redimensionarImagenMaximo(bitmap, 300, 200);
				  imagen.setImageBitmap(bitmap);
				  bitmap=null;
							 // imagen.setImageDrawable(getContext().getResources().getDrawable(
					           //        R.drawable.sinfoto));//}
							  
							  }
			//		  
					    
			   		}else{
			   			  imagen.setImageDrawable(getContext().getResources().getDrawable(
			                        R.drawable.sinfoto));
			   		}
			    	} catch (FileNotFoundException e1) {
					// TODO Auto-generated catch block
			    		e1.printStackTrace();
			   
			    	}
		
			
	
        return (convertView);
    }
    
    @Override
    public long getItemId(int position)
    {
        return getItem(position).getId();
    }
    public Bitmap redimensionarImagenMaximo(Bitmap mBitmap, float newWidth, float newHeigth){
		   //Redimensionamos
		   int width = mBitmap.getWidth();
		   int height = mBitmap.getHeight();
		   float scaleWidth = ((float) newWidth) / width;
		   float scaleHeight = ((float) newHeigth) / height;
		   // create a matrix for the manipulation
		   Matrix matrix = new Matrix();
		   // resize the bit map
		   matrix.postScale(scaleWidth, scaleHeight);
		   // recreate the new Bitmap
		   return Bitmap.createBitmap(mBitmap, 0, 0, width, height, matrix, false);
		}
    
}
