package modelo;

import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.sql.Date;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.GregorianCalendar;
import java.util.HashMap;
import java.util.Map;



import android.net.Uri;
import android.os.Bundle;
import android.app.Activity;
import android.app.Notification;
import android.app.NotificationManager;
import android.app.PendingIntent;
import android.app.TaskStackBuilder;
import android.content.Context;
import android.content.Intent;

import android.util.Log;
import android.view.View;
import android.widget.Button;
import android.app.Notification;
import android.app.NotificationManager;
import android.content.ContentValues;
import android.content.Context;
import android.content.Intent;
import android.database.Cursor;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.media.RingtoneManager;
import android.net.Uri;
import android.support.v4.app.NotificationCompat;

public class Toma {

   

	private Context context;

    private Long id;
    private GregorianCalendar day;
    private Calendar calendario;
    private Integer cantidad;
    private String fecha;
    private String flarga;
    private String hora;
    private boolean tomada;
    private long id_medicamento;
    private boolean notificado;
    private String ftomada;
    private String nombre_medicamento;
    private String foto;
  
    private SimpleDateFormat sm;
    private int dia;
	private int mes;
	private int year;
	private int horas=0;
	private int min=0;
    
 // Variables de la notificacion
    
 
     
//Defino los iconos de la notificacion en la barra de notificacion
    

    public Toma(Context context)
    {
        this.context = context;
    }
    
   public void SumarDia(){
	   
	      
	   Calendar c1 = GregorianCalendar.getInstance();
  
       SimpleDateFormat sdf = new SimpleDateFormat("d/M/yyyy hh:mm:ss");
    
       sdf = new SimpleDateFormat("d/M/yyyy hh:mm:ss");
    
       c1.add(Calendar.DATE, 1);
 
   }
                      
   public String convertirFechaString(Date date){
	   	
	      return new SimpleDateFormat("yyyy-MM-dd HH:mm:ss").format(date);
	   	
	   }

   
     
    public Toma(Context context, Integer cantidad, String fecha, String horaToma, boolean tomado, long medicamento, String nMedicina,  boolean notificado, String fechaTomado){
    	this.setContext(context);
    	this.cantidad=cantidad;
    	this.fecha=fecha;
    	this.hora = horaToma;
    	this.tomada = tomado;
    	this.id_medicamento=medicamento;
    	this.nombre_medicamento=nMedicina;
    	this.setFlarga(setFlarga());
    	this.setNotificado(false);
    	this.setFtomada(fechaTomado);
    	
    	
    }
    public void actualizar(Integer cantidad, String fecha, String horaToma, boolean tomado, long medicamento, String nMedicina,  boolean notificado, String foto, String fechaTomado){
    	this.setContext(context);
    	this.cantidad=cantidad;
    	this.fecha=fecha;
    	this.hora = horaToma;
    	this.tomada = tomado;
    	this.id_medicamento=medicamento;
    	this.nombre_medicamento=nMedicina;
    	this.flarga =setFlarga();
    	this.setNotificado(notificado);
    	this.setFtomada(fechaTomado);
    }
    public GregorianCalendar getDay(){
    return this.day;
}
    public StringBuilder setFlarga(int day, int mes, int year, int hora, int min){
    	
    	StringBuilder fechaUsa = (new StringBuilder().append(year)
				.append("-").append(mes + 1).append("-").append(day).append(" ").append(hora).append(":").append(min).append(":").append("00"));
   
    	
    	
    	
    	return fechaUsa;
    	
    }
    public void postponer(){
    	//postpone la toma una hora
    	Log.d("Postponer", "Paso por posponer");
    	Calendar fechaToma;
    	
    		fechaToma =  Calendar.getInstance();
    		fechaToma.set(this.year,this.mes-1,this.dia,this.horas,this.min,0);
    		setHora("00");
    		this.horas=this.horas-23;
   			fechaToma.add(Calendar.HOUR_OF_DAY, 1);
			this.dia=fechaToma.get(Calendar.DAY_OF_MONTH);
			this.mes=fechaToma.get(Calendar.MONTH);	
			this.min=fechaToma.get(Calendar.MINUTE);
			year=fechaToma.get(Calendar.YEAR);
			 SimpleDateFormat sdf2 = new SimpleDateFormat("dd/MM/yyyy");
			    SimpleDateFormat sdf4 = new SimpleDateFormat("yyyy/MM/dd");
			 
			   
			 			
			
				this.fecha= (sdf2.format(fechaToma.getTime()));
				SimpleDateFormat sdf3 = new SimpleDateFormat("HH:mm");
			
				this.hora = (sdf3.format(fechaToma.getTime()));
    			
			
			StringBuilder n = setFlarga(this.dia, this.mes, this.year, this.horas, this.min);
    		Log.d("Postponer", n.toString());
    		
    		Log.d("Hora", this.hora);
    		Log.d("Fecha", this.fecha);
    	//	setFlarga(n.toString());
    	
		
			
    		
    //	}
    	actualizar(this.cantidad, this.fecha, this.hora,this.tomada, this.getId_medicamento(), this.getNombreMedicamento(), this.notificado, this.getFoto(), this.getFtomada());
		save();
    	
    }
    
    public int getMin(){
    	return this.min;
    }
    public String getFoto(){
    	return this.foto;
    }
    public void setFoto(String f){
    	this.foto= f;
    }
    public String getNombreMedicamento(){
    	return this.nombre_medicamento;
    }
    public String setFlarga(){
    	
    	 int longitud = this.fecha.length();
   		if (longitud==10){
 			//10/12/2015
 			 dia = Integer.parseInt(this.fecha.substring(0, 2));
 			 mes = Integer.parseInt(this.fecha.substring(3, 5));
 			 year= Integer.parseInt(this.fecha.substring(6, 10));
 			
 		}else if(longitud==8){
 			dia = Integer.parseInt(this.fecha.substring(0, 0));
 			 mes = Integer.parseInt(this.fecha.substring(2, 2));
 			 year= Integer.parseInt(this.fecha.substring(4,7));
 				}else{ if(this.fecha.indexOf("-")==1){
 							 dia = Integer.parseInt(this.fecha.substring(0, 0));
 							 mes = Integer.parseInt(this.fecha.substring(2, 3));
 							 year= Integer.parseInt(this.fecha.substring(5,8));
 						}else
 						{
 							 dia = Integer.parseInt(this.fecha.substring(0, 1));
 							 mes = Integer.parseInt(this.fecha.substring(3, 3));
 							 year= Integer.parseInt(this.fecha.substring(5, 8));
 						}
 					
 					
 					
 				}
 		 longitud = this.hora.length();
 		if (longitud==5){
 			 horas = Integer.parseInt(this.hora.substring(0, 2));
 			 min = Integer.parseInt(this.hora.substring(3, 5));
 			 
 			
 			
 		}
 		StringBuilder fechaUsa = (new StringBuilder().append(year) .append("/").append(mes).append("/").append(dia).append(" ").append(hora).append(":").append(min).append(":").append("00"));
    	
    	
    	this.day = new GregorianCalendar(year, mes, dia, getHoraInt(), min);
    	this.min=min;
    	
    	return fechaUsa.toString();
    }

    public Context getContext() {
        return context;
    }

    public void setContext(Context context) {
        this.context = context;
    }

     

    public static Toma cursorToToma(Context context, Cursor c)
    {
        Toma toma = null;

        if (c != null)
        {
        	 toma = new Toma(context);
        	 toma.setId(c.getLong(c.getColumnIndex(TomaDbAdapter.C_COLUMNA_ID)));
        	 toma.setFoto(c.getString(c.getColumnIndex(TomaDbAdapter.C_COLUMNA_FOTO)));
        	 
        	 String hor = c.getString(c.getColumnIndex(TomaDbAdapter.C_COLUMNA_HORA));
             toma.setHora(hor);
        	 toma.setFecha(c.getString(c.getColumnIndex(TomaDbAdapter.C_COLUMNA_FECHA)));
             String cad = c.getString(c.getColumnIndex(TomaDbAdapter.C_COLUMNA_CANTIDAD));
             Integer cada = Integer.parseInt(cad);
        	 toma.setCantidad(cada);
        	 
        	 String tomada = c.getString(c.getColumnIndex(TomaDbAdapter.C_COLUMNA_TOMADA));
        
        	 if (tomada.contentEquals("0"))
        		toma.setTomada(false);
        	 else
        		 toma.setTomada(true);
        	 String medicina = c.getString(c.getColumnIndex(TomaDbAdapter.C_COLUMNA_NOMBRE_MEDICINA));
        	
        	 toma.setNombreMedicina(medicina);
        	 String ftoma = c.getString(c.getColumnIndex(TomaDbAdapter.C_COLUMNA_TOMADA));
        	 String ftoma2 = c.getString(c.getColumnIndex(TomaDbAdapter.C_COLUMNA_MEDICINA));
        	 String ftoma4 = c.getString(c.getColumnIndex(TomaDbAdapter.C_COLUMNA_FLARGATOMA));
        	 String noti = c.getString(c.getColumnIndex(TomaDbAdapter.C_COLUMNA_NOTIFICADA));
        	 if (noti.contentEquals("0"))
        		toma.setNotificado(false);
        	 else
        		 toma.setNotificado(true);
             toma.setId_medicamento(Integer.parseInt(ftoma2));
        	 toma.flarga=toma.setFlarga();
        	 toma.setFtomada(ftoma4);
        	
        	 
         toma.save();
        	 

            
        }
     //   noti = new NotificationActivity();
        //esto falla, recordar las notificaciones se crean cuando se crea una nueva toma
       // noti.displayNotification();
        
        return toma ;
    }
    
  
    private ContentValues toContentValues()
    {
        ContentValues reg = new ContentValues();

        reg.put(TomaDbAdapter.C_COLUMNA_ID, this.getId());
        reg.put(TomaDbAdapter.C_COLUMNA_CANTIDAD, this.getCantidad());
        reg.put(TomaDbAdapter.C_COLUMNA_HORA, this.getHora());
        reg.put(TomaDbAdapter.C_COLUMNA_FECHA, this.getFecha());
        reg.put(TomaDbAdapter.C_COLUMNA_FLARGA, this.getFlarga());
        reg.put(TomaDbAdapter.C_COLUMNA_TOMADA, this.getTomada());
        reg.put(TomaDbAdapter.C_COLUMNA_MEDICINA, this.getId_medicamento());
        reg.put(TomaDbAdapter.C_COLUMNA_NOMBRE_MEDICINA, this.nombre_medicamento);
        reg.put(TomaDbAdapter.C_COLUMNA_NOTIFICADA, this.isNotificado());
        reg.put(TomaDbAdapter.C_COLUMNA_FOTO, this.getFoto());
        reg.put(TomaDbAdapter.C_COLUMNA_FLARGATOMA, this.getFtomada());
       

        return reg;
    }

    public long save()
    {
        TomaDbAdapter dbAdapter = new TomaDbAdapter(this.getContext());
//aqui es donde creamos una nueva toma y habria que generar la notificacin
        // comprobamos si estamos insertando o actualizando según esté o no relleno el identificador
        if ((this.getId() == null) || (!dbAdapter.exists(this.getId())))
        {
            long nuevoId = dbAdapter.insert(this.toContentValues());

            if (nuevoId != -1)
            {
                this.setId(nuevoId);
            }
        }
        else
        {
            dbAdapter.update(this.toContentValues());
        }

        return this.getId();
    }

    public long delete()
    {
        // borramos el registro
        TomaDbAdapter dbAdapter = new TomaDbAdapter(this.getContext());

        return dbAdapter.delete(this.getId());
    }
    public long deleteAll()
    {
        // borramos el registro
        TomaDbAdapter dbAdapter = new TomaDbAdapter(this.getContext());

        return dbAdapter.deleteAll(this.getId());
    }
    public static Toma find(Context context, long id)
    {
    	
    	
    	TomaDbAdapter dbAdapter = new TomaDbAdapter(context);

        Cursor c = dbAdapter.getRegistro(id);

        Toma toma = Toma.cursorToToma(context, c);

        c.close();

        return toma;
    }
    public static Cursor BuscaMedicamento(Context context, long id)
    {
    	
    	
    	TomaDbAdapter dbAdapter = new TomaDbAdapter(context);

        Cursor c = dbAdapter.getRegistroMedicina(id);

        c.close();

        return c;
    }
	public Integer getCantidad() {
		return cantidad;
	}

	public void setCantidad(Integer cantidad) {
		this.cantidad = cantidad;
	}

	

	public boolean isTomada() {
		return tomada;
	}

	public void setTomada(boolean tomada) {
		this.tomada = tomada;
	}
	public void setNombreMedicina(String medicina) {
		this.nombre_medicamento=medicina;
	}
	public Long getId() {
		return id;
	}

	public void setId(Long id) {
		this.id = id;
	}

	public String getFecha() {
		return fecha;
	}

	public void setFecha(String fecha) {
		this.fecha = fecha;
	}

	public String getHora() {
		return hora;
	}

	public void setHora(String hora) {
		this.hora = hora;
	}



	public void setId_medicamento(Integer id_medicamento) {
		this.id_medicamento = id_medicamento;
	}
	public Boolean getTomada() {
		return tomada;
	}

	public void setTomada(Boolean tomada) {
		this.tomada = tomada;
	}

	public long getId_medicamento() {
		return id_medicamento;
	}

	public void setId_medicamento(long id_medicamento) {
		this.id_medicamento = id_medicamento;
	}

	public String getFlarga() {
		return flarga;
	}

	public void setFlarga(String flarga) {
		this.flarga = flarga;
	}
	public void sumarDia(Integer numeroDias){
		
	}
	public Date sumarRestarDiasFecha(Date fecha, int dias){
				
		      Calendar calendar = Calendar.getInstance();
		      calendar.setTime(fecha); // Configuramos la fecha que se recibe
		      calendar.add(Calendar.DAY_OF_YEAR, dias);  // numero de das a aadir, o restar en caso de das<0
		      return (Date) calendar.getTime(); // Devuelve el objeto Date con los nuevos das aadidos
		 
	
		 }
	public Date sumarRestarHorasFecha(Date fecha, int horas){
		      Calendar calendar = Calendar.getInstance();
		      calendar.setTime(fecha); // Configuramos la fecha que se recibe
		      calendar.add(Calendar.HOUR, horas);  // numero de horas a aadir, o restar en caso de horas<0
		      return (Date) calendar.getTime(); // Devuelve el objeto Date con las nuevas horas aadidas
			 }
	public int getHoraInt(){
		return horas;
	}
	public int getDiaInt(){
		return dia;
	}

	public String getFtomada() {
		return ftomada;
	}

	public void setFtomada(String ftomada) {
		this.ftomada = ftomada;
	}

	public boolean isNotificado() {
		return notificado;
	}

	public void setNotificado(boolean notificado) {
		this.notificado = notificado;
	}
}
